'use strict';

(function($) {
  var woofsTimeout = null;

  $(document).ready(function() {
    woofs_options();
    woofs_arrange();
  });

  $(document).on('change', 'select[name="_woofs_change_price"]', function() {
    woofs_options();
  });

  // search input
  $(document).on('keyup', '#woofs_keyword', function() {
    if ($('#woofs_keyword').val() != '') {
      $('#woofs_loading').show();

      if (woofsTimeout != null) {
        clearTimeout(woofsTimeout);
      }

      woofsTimeout = setTimeout(woofs_ajax_get_data, 300);
      return false;
    }
  });

  // actions on search result items
  $(document).on('click touch', '#woofs_results li', function() {
    $(this).children('span.remove').html('×');
    $('#woofs_selected ul').append($(this));
    $('#woofs_results').hide();
    $('#woofs_keyword').val('');
    woofs_get_ids();
    woofs_arrange();
    return false;
  });

  // change qty of each item
  $(document).on('keyup change click', '#woofs_selected input', function() {
    woofs_get_ids();
    return false;
  });

  // actions on selected items
  $(document).on('click touch', '#woofs_selected span.remove', function() {
    $(this).parent().remove();
    woofs_get_ids();
    return false;
  });

  // hide search result box if click outside
  $(document).on('click touch', function(e) {
    if ($(e.target).closest($('#woofs_results')).length == 0) {
      $('#woofs_results').hide();
    }
  });

  function woofs_options() {
    if ($('select[name="_woofs_change_price"]').val() == 'yes_custom') {
      $('input[name="_woofs_change_price_custom"]').show();
    } else {
      $('input[name="_woofs_change_price_custom"]').hide();
    }
  }

  function woofs_arrange() {
    $('#woofs_selected ul').sortable({
      handle: '.move',
      update: function(event, ui) {
        woofs_get_ids();
      },
    });
  }

  function woofs_get_ids() {
    var listId = new Array();
    $('#woofs_selected li').each(function() {
      listId.push($(this).attr('data-id') + '/' +
          $(this).find('.price input').val() + '/' +
          $(this).find('.qty input').val());
    });
    if (listId.length > 0) {
      $('#woofs_ids').val(listId.join(','));
    } else {
      $('#woofs_ids').val('');
    }
  }

  function woofs_ajax_get_data() {
    // ajax search product
    woofsTimeout = null;
    var data = {
      action: 'woofs_get_search_results',
      woofs_keyword: $('#woofs_keyword').val(),
      woofs_id: $('#woofs_id').val(),
      woofs_ids: $('#woofs_ids').val(),
    };
    $.post(ajaxurl, data, function(response) {
      $('#woofs_results').show();
      $('#woofs_results').html(response);
      $('#woofs_loading').hide();
    });
  }
})(jQuery);